<template>
    <span :style="cellStyle">
        <span v-if="isDictionaryValues">{{multipleValues}}</span>
        <text-diff v-else-if="isTextDiff" :older="textDiff.older" :newer="textDiff.newer" :mode="config.mode" />
        <a v-else-if="isURL" :href="value" class="link" target="_blank">{{value}}</a>
        <image-viewer v-else-if="isImage && value" :src="value" :alt="value" />
        <video-link-editor v-else-if="isVideo" :value="value" :popupTitle="config.popupTitle" :disabled="true" />
        <span v-else>{{value}}</span>
        <validation-box v-if="validationPath" :message="validationParams.message" :is-invalid="validationParams.invalid" />
    </span>
</template>

<script>
import {
    SELECT, MULTISELECT, URL, IMAGE_VIEWER, VIDEO_VIEWER,
} from '@/constants/ui/details';
import { ImageViewer } from '@/components/MediaViewer';
import TextDiff from '@/components/TextDiff';
import { VideoLinkEditor } from '@/components/MediaURLEditor';
import ValidationBox from '@bloomio/spa-admin-common/components/validation-box';
import validationMixin from '@bloomio/spa-admin-common/mixins/validationMixin';

export default {
    components: {
        ImageViewer,
        TextDiff,
        VideoLinkEditor,
        ValidationBox,
    },
    mixins: [validationMixin],
    props: {
        /** cell id */
        id: {
            type: String,
            required: true,
        },
        /** current value */
        value: {
            type: null,
            required: false,
        },
        /** control settings */
        config: {
            type: Object,
            required: false,
            default: () => {},
        },
    },
    computed: {
        isDictionaryValues: vm => vm.config && [SELECT, MULTISELECT].indexOf(vm.config.type) > -1,
        isTextDiff: vm => vm.config && vm.config.type === 'TextDiff',
        isURL: vm => vm.config && vm.config.dataType === URL,
        isVideo: vm => vm.config && vm.config.dataType === VIDEO_VIEWER,
        isImage: vm => vm.config && vm.config.dataType === IMAGE_VIEWER,
        textDiff: vm => (vm.config.fromDictionary ? {
            older: vm.$store.getters.dictionaryValue(vm.id, vm.value.older),
            newer: vm.$store.getters.dictionaryValue(vm.id, vm.value.newer),
        } : vm.value),
        multipleValues: (vm) => {
            const values = vm.$store.getters.dictionaryValue(vm.id, vm.value);
            if (values) {
                if (Array.isArray(values)) {
                    return values.length ? values.join(', ') : '';
                }
                return values;
            }
            return '';
        },
        cellStyle: () => ({ display: 'inline-block', width: '100%' }),
    },
};
</script>
